# Release Notes

## 6.17.22 (RC)

* New module: appstore.

## 6.17.21 (2015-04-17)

* New facility to encrypt secret information in the db. To use it, set a 16char encryption key in
  application-secret-key.conf and migrate the unencrypted data via crash command "oauth1 encrypt".
  Transparent upgrade is possible, i.e. as long as the propert "secret.key" in this file is unset,
  epagesj will warn during startup, but will be working in a non-encrypting mode.
  DO NOT CHANGE THIS KEY ONCE IT WAS SET.

* New facility to put epagesj into maintenance mode. Use the resource "/rs/server-status" in your
  load balancer to check epagesj availability. epagesj will check if the file $EPAGESJ_CONFIG/maintenance.lock
  exists, and will return "503 Service Unavaiable" in this case.
  It only affects the resource above, not the other resources, so it is only supposed to be used
  in a load-balanced environment.

## 6.17.20 (2015-04-07)

* No significant changes.

## 6.17.19 (2015-04-02)

### Configuration changes

* Created new configuration key: Jpa.profiler. Possible values are: NoProfiler (DEFAULT), PerformanceMonitor, PerformanceProfiler, QueryMonitor, DMSProfiler
  For more information, see org.eclipse.persistence.config.PersistenceUnitProperties

* Fixed package names for in logback-epagesj.xml (com.epages.product -> com.epages.metadata.product)

* Removed: core optimizer facility, as it did not scale too well, and native
  merging facilities of solr should be sufficient. This means the following
  config keys are obsolete:
  * Solr.autoOptimizeAfterReachingSegments
  * Solr.autoOptimizeSegmentsDivider
  * Solr.autoOptimizeCheckInSecs
  * Solr.autoOptimizeAwaitTerminationInMillis

## 6.17.18 (2014-03-11)

* Fixes creation of Carts via REST
* Removed Windows support

## 6.17.17 (2014-02-15)

* Requires epages6 6.17.16 for Category REST

### Library upgrades (not complete)

Starting with this version only major upgrades will be reported in the release notes.

* jetty:9.2.9.v20150224 (security fix)

## 6.17.15 + 6.17.16 (skipped)

## 6.17.14.3 (2014-02-23)

* Bugfix release for getting multiple products by id on the products resource. (AD-426, AD-439)

## 6.17.14.2 (2014-02-17)

* Reverts the changed mapping of types in mongodb back to the old class names
  to ensure patching with zero downtime, without having to reindex all shops. (AD-249)
  May require reindexing of all shops, if 6.17.14.1 was deployed before.

## 6.17.14.1 (2014-02-03) DO NOT USE IN PRODUCTION

* Bugfix release for token deletion.

### Library Upgrades

* slf4j:1.7.10, junit:4.12, mockito:1.10.19, joda-time:2.7, spring-core:4.1.4.RELEASE, tomcat-jdbc:8.0.17,
  flyway:3.1, jetty:9.2.7.v20150116, hibernate-validator:5.1.3.Final, solr:4.10.3, pdfbox:1.8.8,
  logstash-logback-encoder:3.6, javax-el:2.2.5 (downgrade), assertj:1.7.1

### Known Isssue

* Changes the mapping inside the mongo collections of category and attributes, thus requires
  a reindex.

## 6.17.14 (2014-01-19) DO NOT USE IN PRODUCTION

### Known Issues

* Has a critical issue: when deleting a token, it will also delete the consumer linked to it

* Important: Moved OAuth token management from mongo to mysql. This requires calling
  a manual upgrade step (see https://epages.atlassian.net/wiki/display/RND/OAuth1+Data+Migration).

* Important: The logic to split search results by product image has been removed. This means
  the search will return master products just like epages6 SF would when listing products within
  categories.

* Important: If Shop.strictHostHeaderCheck=true epagesj will use the ASPoolDBCacheServer to look up
  Storename and ShopGUID. This requires permission to open UDP connections from epagesj to
  ASPoolDBCacheServer.

### Configuration changes

* New configuration section "Console" with following options:

  - refreshTimeInSecs (default=0)
  - username (default=admin)  username used for authentication mode 'simple'
  - password (default=admin)  password used for authentication mode 'simple'
  - sshPort  (default=2000    Port to bind SSH service to.
  - auth     (default=key, simple) authentication modes to use. simple=username,password based authentication, key=ssh-key based authentication
  - sshServerKeyfile  (default=hostkey.pem) file for ssh host key
  - sshServerKeygen   (default=true) If true, auto-generate ssh host key, base directory is 'conf'
  - authPath          (default=authorized_key.pem) Public key which is auhtorized to connect.
                      To generate this file from an existing SSH key, 
                      run ``openssl rsa -in id_rsa -pubout -outform pem > authorized_key.pem``

### New services

* ePagesJ offers a remote console for administrative tasks, like SQL schema migrations, which
  is accessible via SSH on port 2000.

### Library Upgrades

* jsr305:3.0.0, guice:4.0-beta5, junit:4.12-beta-3, mockito:1.10.14, joda-time:2.5, spring:4.1.2.RELEASE, hsqldb:2.3.2 (NEW)
  mysql-connector-java:5.1.34, tomcat-jdbc:8.0.15, spring-batch:3.0.2.RELEASE, spring-hateoas:0.16.0.RELEASE, 
  spring-data-mongodb:1.6.1.RELEASE, eclipselink:2.5.2 (NEW), jpa:2.1.0 (NEW), jersey:2.13, jersey2-guice:0.5 (NEW),
  jetty:9.2.5.v20141112, solr:4.10.2, flying-saucer-pdf:9.0.7, pdfbox:1.8.7, logstash-logback-encoder:3.4,
  jsoup:1.8.1, nvi18n:1.14, assertj:1.7.0, 

## 6.17.11 + 6.17.12 + 6.17.13 have not been released.

## 6.17.10.1 / 6.17.9.4 (2014-11-03)

* Bugfix release for EPG-36182

* Equivalent content for both versions.

## 6.17.10 / 6.17.9.3 (2014-10-29)

* Equivalent content for both versions.

### Library Upgrades

* Reverted jaxb downgrade as current amazon payments SDK is compatible now.

* Downgraded commons-httpclient to 3.0.1. This is the version that amzon-payments-sdk expects.

* guava:18.0, tomcat-jdbc:8.0.12, jersey:2.12, hk2:2.3.0.b10, solr:4.10.0, logstash-logback-encoder:3.1,
  epages-soapclient:1.4.16, commons-httpclient:3.0.1, amazon-payments-sdk:1.0.11

## 6.17.9.0.1 (2014-10-21)

* Backported fixes for EPG-36024 and EPG-36066.

## 6.17.9 (2014-08-28)

### Library Upgrades

* joda-time:2.4, mysql-connector-java:5.1.32, spring-batch:3.0.1.RELEASE, jersey:2.11, hibernate-validator:5.1.2.Final,
  jetty:9.2.2.v20140723, logstash-logback-encoder:3.0, jaxrs-api:2.0.1, httpclient:4.3.5, httpcore:4.3.2,
  amazon-payments-sdk:1.0.10, jaxb:2.1.13 (library downgrade for compatibility reasons with amazon payments SDK)

## 6.17.8 (2014-08-04)

### Configuration Changes

* Work-around for automatic connection retry on a stand-alone mongodb not possible anymore. This means Mongo.hosts
  configurations like "localhost:27017,localhost:27017" are *not valid anymore* and need to be changed, or epagesj
  will not start. It also means that if you restart mongodb, while keeping epagesj up, the first operation going
  to the mongodb server will fail with a socket error. Please use mongodb in a replica-set, if possible.

* Jetty does not automatically follow symlinks anymore. Use EPagesJServer.followSymlinks=true to enable this,
  if needed. (default is false)

### Library Upgrades

* jersey:2.10.1, spring-data-mongodb:1.5.1.RELEASE, flyway:3.0, java-mongo-driver:2.12.1 (implied by spring-data-mongodb)

## 6.17.7 (2014-07-02)

* Support for passing HTTP Proxy settings via Environment variables (e.g. http_proxy=http://localhost:8888  
  https_proxy=http://localhost:8888 no_proxy=172.19.50.1/8), can also be set as System properties with the same
  identifier (-Dhttp_proxy=..)

### Library Upgrades

* spring:4.0.5.RELEASE, mysql:5.1.31, tomcat-jdbc:8.0.9, spring-batch:2.2.7.RELEASE, spring-hateoas:0.14.0.RELEASE,
  spring-data-mongodb:1.4.3.RELEASE, jersey:2.10, jetty:9.2.1.v20140609, solr:4.9.0, pdfbox:1.8.6, 
  jacoco:0.7.1.201405082137, logstash-encoder:2.8, nvi18n:1.13, jackson2:2.4.1, commons-lang3:3.3.2

## 6.17.6 (2014-06-19)

### Known Issues

* DO NOT USE FOR PRODUCTION: Contains bug for outgoing links not respecting SSL context.

### Library Upgrades

* guava:17.0, guice:4.0-beta4, spring:4.0.4.RELEASE, spring-batch:2.2.6.RELEASE, spring-hateoas:0.11.0.RELEASE,
  jersey:2.9, hk2 (2.3.0-b05), hibernate-validator:5.1.1.Final, jetty:9.1.5.v20140505, solr:4.8.0, pdfbox:1.8.5,
  epages-soapclient:1.4.15, jackson2:2.3.3

## 6.17.5.1 (2014-05-12)

* Bugfix release for public REST API.

* Support for setting HTTP proxy settings as System properties. (EPagesJ.httpProxyHost, EPagesJ.httpProxyPort, 
  EPagesJ.httpsProxyHost, EPagesJ.httpsProxyPort, EPagesJ.httpNonProxyHosts)

## 6.17.5 (2014-05-12)

* JSON/XML serialization migrated to Jackson2! XML serialization may be incompatible and
  will be dropped in a future version of 6.17.

* Documentation of public REST API migrated from jax-doclets to RAML

### Known Issues

* DO NOT USE FOR PRODUCTION: Contains bugs for not checking the public shop id on the public REST API, 
  and outgoing links not respecting SSL context.

### Configuration changes

* New configuration option Shop.strictHostHeaderCheck (boolean). Controls strictness of checking
  of the incoming request. If set to true (default for production) the host header will
  need to match the host set as system or shop domain. Does not yet consider multiple
  domains per shop feature.

### Library Upgrades

* slf4j:1.7.7, logback:1.1.2, spring:4.0.3.RELEASE, mysql-connector-java:5.1.30,
  tomcat-jdbc:8.0.5, spring-hateoas:0.10.0.RELEASE, hk2:2.3.0-b04,
  hibernate-validator:5.1.0.Final, jetty:9.1.4.v20140401, solr:4.7.2,
  flying-saucer-pdf:9.0.6, logstash-logback-encoder:2.6, selenium:2.41.0,
  epages-soapclient:1.4.14, nvi18n:1.1

### Solr related changes (reindexing required)

* Indexing change: Unified Predef- and other string fields for faceting. (EPG-31849)

* Cleanup of attributes cache in mongo required (db.attributes.drop())

## 6.17.4 (2014-03-24)

### Library Upgrades

* slf4j:1.7.6, logback:1.1.1, guava:16.0.1, spring:4.0.2.RELEASE, joda_convert:1.6,
  mysql-connector-java:5.1.29, spring-batch:2.2.5.RELEASE, spring-data-mongodb:1.4.1.RELEASE,
  jersey:2.7, hk2:2.3.0-b01, jetty:9.1.3.v20140225, solr:4.7.0, pdfbox:1.8.4,
  logstash-logback-encoder:2.5, selenium:2.40.0, groovy:2.2.2, epages-soapclient:1.4.12,
  nv18n:1.11, jackson:1.9.13, jackson2:2.3.2, spring-hateoas:0.9.0.RELEASE

### Configuration changes

* New config option. ServiceApiSoap.productAvailabilityTextEnabled. Defaults to false.
  Used to control the fetching of product attribute "AvailabilityText", which was introduced in 6.17.4.
  Only enable, if epages perl version is 6.17.4 or higher.

## 6.17.3 (2014-02-06)

### Library Upgrades

* spring-data-mongodb:1.3.3-RELEASE, solr:4.6.1, epages-soapclient:1.4.8

### Configuration changes

* New config section: ServiceApiSoap. Used to configure connection parameters to epages6 SOAP interface.
  maxConnections=20 (max http connections total), maxConnectionsPerHost=10 (max http connections per hostname)

## 6.17.2 (2014-01-16)

### Library Upgrades

* mysql-connector-java:5.1.28, flyway-gradle-plugin:2.3.1, selenium:2.39.0, findbugs:2.0.3,
  hk2:2.2.0, xhtmlrenderer:9.0.4, jersey:2.5.1, spring:4.0.0, jetty:9.1.1, epages-soapclient:1.4.7,
  solr:4.6.0

## 6.16.8 (2014-01-15)

* Maintainance release due to library upgrade.

### Library Upgrades

* xhtmlrenderer:9.0.4

## 6.17.1 (2013-12-18) - DO NOT USE IN PRODUCTION.

* Re-added Pdf.baseUrl configuration property, to be able to resolve URLs for PDFs, if WebRoot is not available
  locally. (also contained in 6.16.5)

### Known Issues

* PermGen MemoryLeak in HK2!

* PDF rendering using local/NFS resolution broken!

## 6.17.0

### Configuration changes

* No more automatic task recovery, so Task.recovererDelayInMillis configuration option is removed.
  Instead you should use the REST API to trigger task recovery based on task status, storename or
  shop GUID. (/rs/queue/recovery)

* New ENV variable EPAGESJ_LOG_ARCHIVE. If set, logback will rotate into this directory, if unset
  archives still go into ./logs/archive/

### Solr related changes (reindexing required)

* Indexing change: New field "ObjectPath" in schema.xml

## 6.16.7 (2013-12-18)

### Confugration changes

* Bugfix release without configuration changes.

### Breaking API changes

* XML serialization of task status changed to upper case, to be consistent with JSON.
  Beware that XML serialization is deprecated, and may be discontinued in a future version
  of epagesj.

### Library Upgrades

* hk2:2.2.0-b27, jersey:2.4.1

## 6.16.6 (2013-12-10) - DO NOT USE IN PRODUCTION.

### Configuration changes

* Bugfix release without configuration changes.

* Does not contain the new Public REST API.

### Known Issues

* PermGen MemoryLeak in HK2!

## 6.16.5 (2013-11-28) - DO NOT USE IN PRODUCTION.

* Internal release containing new public REST API, based on 6.17.0 development.

## 6.17.0 (2013-10-25)

## 6.16.4 (2013-10-09)

* Bugfix release without configuration changes.

## 6.16.3 (2013-09-19)

* Bugfix release without configuration changes.

## 6.16.2 (2013-08-21)

### Configuration changes

* Added logstash-compatible logger in logback-epagesj.xml and logback-solr.xml (disabled by default)

## 6.16.1 (2013-08-06)

### Configuration changes

* Configuration for disabling the "sorting by position" removed again. The algorithm has been
  rewritten for better scalability. (Index.sortingByPositionEnabled)

* Small change on logback-epagesj.xml : Set com.epages.product.reader explicitly to "WARN" to avoid
  possible problems, when user is setting DEBUG on root logger.

## 6.15.8 (2013-07-01)

* Bugfix release without config changes.

* Added review changes for sorting algorithm.

## 6.16.0 (2013-06-26)

### Configuration changes

* recovererDelayInMillis set to -1. This disables task recovery by default. In most cases task recovery is
  not wanted. Instead you should schedule a full reindex for your shops.

## 6.15.7 (2013-06-11)

* Backport of replaced sorting algorithm.

## 6.15.6 (2013-05-27) - DO NOT USE IN PRODUCTION

### Known Issues

* Has a critical issue on task rescheduling. Do not use!

## 6.15.5 (2013-05-17)

### Configuration changes

* Configuration for disabling the new "sorting by position" added. This feature is known to cause problems on big
  installations. The default has been set to "off" (Index.sortingByPositionEnabled - default:false)

## 6.15.4 (2013-04-12)

### Configuration changes

* Auto-generation of epagesj.sample.conf. This causes this file to look completely different, although the relevant
  configuration changes are just the ones below.

* Server section moved to EPagesJServer

* Changed SolrClient.updateQueueSize default from 500 to 50. This makes memory consumption of epagesj more stable in
  cases, where Solr cannot keep up. This has not been seen in production yet. It is more a safety measure.

* Changed SolrClient.addDocsBufferSize default from 500 to 100. Same here. Don't accumulate too many documents to stabilize
  memory consumption.

* Changed Solr.autoOptimizeCheckInSecs default from 120 to 3600. Only check if core optimization is necessary once every hour.
  This should be disabled completely on big sites anyway. core optimization is a very expensive operation in
  solr and only brings short-term benefits because of constant index fragmentation due to index updates.
  Usually the merge strategy configured inside solr is good enough to keep index fragmentation on a stable level.

* Changed DSPool.maxWait default from 1000 to 30000. 30 seconds is the default for webapps to wait for a database connection.
  We experienced production sites that could not free database connections quick enough, which was causing tasks
  to fail.

## 6.15.3 (2013-05-28)

### Configuration changes

* Merged all search and suggest field configurations into two remaining entries: Search.suggestQueryfields and Search.searchQueryfields
  We replaced the phonetic index all together. As a replacement we introduced a spell-checking fallback query implementation with
  a spellcheck index on product name, manufacturer and category names.

## Manual update steps

* Drop the Mongo collections: "use epagesj; db.tasks.drop(); db.attributes.drop(); db.categories.drop();"

* Reindex all Stores: $PERL $EPAGES_CARTRIDGES/DE_EPAGES/RemoteSearch/Scripts/manageIndex.pl -storename Store -update -all
